<?php

namespace App\Http\Controllers;

use App\Helper\Helper;
use App\Http\Controllers\Controller;
use App\Model\PharmaviteModel;
use Illuminate\Http\Request;
use Log;

class PharmaviteController extends Controller {

    private $pharmaviteObj;
    private $helperObj;
    public function __construct() {

        $this->pharmaviteObj = new PharmaviteModel();
        $this->helperObj = new Helper();
    }

    /**
     * phvContactus post request
     */
    public function nmContactUs(Request $request) {

        $requestData = $request->input('data');
        if (empty($requestData)) {
            $returnData = [
                'error' => 'Invalid endpoint request',
            ];
            $message = 'Failed';
            Log::error("nmContactUs: Invalid endpoint request, request:".$requestData);
            if (!empty($request->input('callback'))) {
                return $this->returnData($request->input('callback'), '600', $message, $returnData);
            } else {
                return $this->returnData(null, '600', $message, $returnData);
            }
        }
        $receivedData = json_decode($requestData);
        // $requestKeys = ['InquiryType', 'SubInquiryType', 'Reason', 'OrderNumber', 'Email', 'FirstName', 'LastName', 
        // 'AddressLine1', 'City', 'State', 'Zip', 'MessageBody'];
        // $optionalParameters = ['StorePurchased', 'Lot', 'Subject', 'AddressLine2'];
        // $keysInTheRequest = [];
        // $emptyValueKeys = [];
        // foreach ($receivedData as $key => $recValue) {

        //     $keysInTheRequest[] = $key;
        //     if (empty(trim($recValue)) && in_array($key, $optionalParameters) == false) {
        //         $emptyValueKeys[] = $key;
        //     }
        // }
        // $keyComparedStatus = array_diff($requestKeys, $keysInTheRequest);
        // if (!empty($keyComparedStatus)) {

        //     $missedParameters = implode(",", $keyComparedStatus);
        //     $message = 'Failed';
        //     $returnData = [
        //         'error' => $missedParameters . ' endpoint parameters are missing in the request',
        //     ];
        //     $this->helperObj->logMe('error : ' . $missedParameters . ' endpoint parameters are missing in the request', $this->logFiles['log']['filename']);
        //     return $this->returnData($request->input('callback'), '600', $message, $returnData);
        // }
        // if (!empty($emptyValueKeys)) {

        //     $emptyValueKeys = implode(",", $emptyValueKeys);
        //     $message = 'Failed';
        //     $returnData = [
        //         'error' => $emptyValueKeys . ' endpoint parameter values are empty in the request',
        //     ];
        //     $this->helperObj->logMe('error : ' . $emptyValueKeys . ' endpoint parameter values are empty in the request', $this->logFiles['log']['filename']);
        //     return $this->returnData($request->input('callback'), '600', $message, $returnData);
        // }
        $postPath = env('POST_NMCONTACT_URL', true);
        $response = $this->pharmaviteObj->postRequestData($postPath, $requestData);
        //print_r($response);
        if (strtolower(trim($response)) != 'success') {

            $message = 'Failed';
            $returnData = [
                'error' => 'Error occured while posting the request to the API',
                'request' => $requestData,
            ];
            Log::error('nmContactUs: Error occured while posting the request to the API, request:'.$requestData);
            return $this->returnData($request->input('callback'), '600', $message, $returnData);
        }
        $emailAddress = !empty($receivedData->Email) ? $receivedData->Email : '';
        $message = 'Success';
        $returnData = [
            'message' => 'Successfully posted the given request in the API (Email: ' . $emailAddress . ')',
        ];
        Log::info('nmContactUs:'.json_encode($returnData));
        return $this->returnData($request->input('callback'), '200', $message, $returnData);
    }


    /**
     * nmmbg post request
     */
    public function nmmbg(Request $request) {

        $requestData = $request->input('data');
        if (empty($requestData)) {

            $returnData = [
                'error' => 'Invalid endpoint request',
            ];
            $message = 'Failed';
            Log::error("nmmbg: Invalid endpoint request, request:".$requestData);
            if (!empty($request->input('callback'))) {
                return $this->returnData($request->input('callback'), '600', $message, $returnData);
            } else {
                return $this->returnData(null, '600', $message, $returnData);
            }
        }
        $receivedData = json_decode($requestData);
        //$requestKeys = ['EMail', 'FirstName', 'LastName', 'AddressLine1', 'City', 'State', 'Zip', 'ReturnProductId', 'ProductListNumber'];
        // $requestKeys = ['Reason','StorePurchased','Lot','Email','FirstName','LastName','AddressLine1','City','State',
        // 'Zip','Subject','MessageBody'];
        // $optionalKeys = ['AddressLine2'];
        // $keysInTheRequest = [];
        // $emptyValueKeys = [];
        // foreach ($receivedData as $key => $recValue) {

        //     $keysInTheRequest[] = $key;
        //     if (empty(trim($recValue)) && !in_array($key, $optionalKeys)) {

        //         $emptyValueKeys[] = $key;
        //     }
        // }
        // $keyComparedStatus = array_diff($requestKeys, $keysInTheRequest);
        // if (!empty($keyComparedStatus)) {

        //     $missedParameters = implode(",", $keyComparedStatus);
        //     $message = 'Failed';
        //     $returnData = [
        //         'error' => $missedParameters . ' endpoint parameters are missing in the request',
        //     ];
        //     $this->helperObj->logMe('error : ' . $missedParameters . ' endpoint parameters are missing in the request', $this->logFiles['log']['filename']);
        //     return $this->returnData($request->input('callback'), '600', $message, $returnData);
        // }
        // if (!empty($emptyValueKeys)) {

        //     $emptyValueKeys = implode(",", $emptyValueKeys);
        //     $message = 'Failed';
        //     $returnData = [
        //         'error' => $emptyValueKeys . ' endpoint parameter values are empty in the request',
        //     ];
        //     $this->helperObj->logMe('error : ' . $emptyValueKeys . ' endpoint parameter values are empty in the request', $this->logFiles['log']['filename']);
        //     return $this->returnData($request->input('callback'), '600', $message, $returnData);
        // }
        $postPath = env('POST_NMMBG_URL', true);
        $response = $this->pharmaviteObj->postRequestData($postPath, $requestData);
        if (strtolower(trim($response)) != 'success') {

            $message = 'Failed';
            $returnData = [
                'error' => 'Error occured while posting the request to the API',
                'request' => $requestData,
            ];
            Log::error('nmmbg: Error occured while posting the request to the API, request:'.$requestData);
            return $this->returnData($request->input('callback'), '600', $message, $returnData);
        }
        $emailAddress = !empty($receivedData->Email) ? $receivedData->Email : '';
        $message = 'Success';
        $returnData = [
            'message' => 'Successfully posted the given request in the API (Email: ' . $emailAddress . ')',
        ];
        Log::info('nmmbg:'.json_encode($returnData));
        return $this->returnData($request->input('callback'), '200', $message, $returnData);
    }

    /**
     * Response message function
     */
    public function returnData($jsonCallback = null, $status, $message, $error) {

        $returnData = array(
            'status' => $status,
            'message' => $message,
            'body' => $error,

        );
        if (!empty($jsonCallback)) {

            echo $jsonCallback . '(' . json_encode($returnData) . ')';
            die();
        } else {

            return response()->json($returnData);
        }
    }
}
