<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Model\IterableApi;
use Log;

use Osiset\BasicShopifyAPI\BasicShopifyAPI;
use Osiset\BasicShopifyAPI\Options;
use Osiset\BasicShopifyAPI\Session;


class TestController extends Controller
{
    public $iterableObj;

    public function __construct()
    {
        // die('tewt');
        $this->iterableObj = new IterableApi();
        $options = new Options();
        // $options->setType(true); // Makes it private
        $options->setVersion(env('SHOPIFY_API_VER_DEV'));

        $this->api = new BasicShopifyAPI($options);

        $this->api->setSession(new Session(env('SHOPIFY_URL_DEV'), env('SHOPIFY_API_PASSWORD_DEV')));

        $this->processData();
        
    }

    function processData() {
        //$response = '{"id":2706454642776,"email":"","closed_at":null,"created_at":"2020-10-11T19:59:35-07:00","updated_at":"2020-10-11T20:23:43-07:00","number":2439,"note":"","token":"9cbfd620c2c2917e3e264d43851dcfe4","gateway":"manual","test":false,"total_price":"160.77","subtotal_price":"160.77","total_weight":18143,"total_tax":"17.23","taxes_included":true,"currency":"CAD","financial_status":"partially_paid","confirmed":true,"total_discounts":"0.00","total_line_items_price":"160.77","cart_token":null,"buyer_accepts_marketing":false,"name":"#3439","referring_site":null,"landing_site":null,"cancelled_at":null,"cancel_reason":null,"total_price_usd":"122.60","checkout_token":null,"reference":null,"user_id":40722038872,"location_id":4928765993,"source_identifier":null,"source_url":null,"processed_at":"2020-10-11T19:59:35-07:00","device_id":null,"phone":null,"customer_locale":null,"app_id":1354745,"browser_ip":null,"landing_site_ref":null,"order_number":3439,"discount_applications":[],"discount_codes":[],"note_attributes":[{"name":"Final : 1\" Mini Blind 8 Gauge","value":2},{"name":"Final : 1\" Premier Basswood Blinds","value":1},{"name":"Final : 1\" Signature Faux Wood Blinds","value":1}],"payment_gateway_names":["manual"],"processing_method":"manual","checkout_id":null,"source_name":"shopify_draft_order","fulfillment_status":null,"tax_lines":[{"price":"7.18","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"7.18","currency_code":"CAD"},"presentment_money":{"amount":"7.18","currency_code":"CAD"}}},{"price":"10.05","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"10.05","currency_code":"CAD"},"presentment_money":{"amount":"10.05","currency_code":"CAD"}}}],"tags":"lineitem updated","contact_email":null,"order_status_url":"https:\/\/p80w-devstore-8.myshopify.com\/31051616\/orders\/9cbfd620c2c2917e3e264d43851dcfe4\/authenticate?key=7e112ac504355a12a575fb1a42db060e","presentment_currency":"CAD","total_line_items_price_set":{"shop_money":{"amount":"160.77","currency_code":"CAD"},"presentment_money":{"amount":"160.77","currency_code":"CAD"}},"total_discounts_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"total_shipping_price_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"subtotal_price_set":{"shop_money":{"amount":"160.77","currency_code":"CAD"},"presentment_money":{"amount":"160.77","currency_code":"CAD"}},"total_price_set":{"shop_money":{"amount":"160.77","currency_code":"CAD"},"presentment_money":{"amount":"160.77","currency_code":"CAD"}},"total_tax_set":{"shop_money":{"amount":"17.23","currency_code":"CAD"},"presentment_money":{"amount":"17.23","currency_code":"CAD"}},"line_items":[{"id":5744010592344,"variant_id":33369633259608,"title":"1\" Mini Blind 8 Gauge","quantity":2,"sku":"M-1AH-8G","variant_title":null,"vendor":"FDB","fulfillment_service":"manual","product_id":4764882403416,"requires_shipping":true,"taxable":true,"gift_card":false,"name":"1\" Mini Blind 8 Gauge","variant_inventory_management":"shopify","properties":[],"product_exists":true,"fulfillable_quantity":2,"grams":4536,"price":"39.80","total_discount":"0.00","fulfillment_status":null,"price_set":{"shop_money":{"amount":"39.80","currency_code":"CAD"},"presentment_money":{"amount":"39.80","currency_code":"CAD"}},"total_discount_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"discount_allocations":[],"tax_lines":[{"price":"1.78","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.78","currency_code":"CAD"},"presentment_money":{"amount":"1.78","currency_code":"CAD"}}},{"price":"1.78","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.78","currency_code":"CAD"},"presentment_money":{"amount":"1.78","currency_code":"CAD"}}},{"price":"2.49","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.49","currency_code":"CAD"},"presentment_money":{"amount":"2.49","currency_code":"CAD"}}},{"price":"2.49","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.49","currency_code":"CAD"},"presentment_money":{"amount":"2.49","currency_code":"CAD"}}}]},{"id":5744010625112,"variant_id":33369633423448,"title":"1\" Premier Basswood Blinds","quantity":1,"sku":"M-1BW","variant_title":null,"vendor":"p80w-devstore-8","fulfillment_service":"manual","product_id":4764882501720,"requires_shipping":true,"taxable":true,"gift_card":false,"name":"1\" Premier Basswood Blinds","variant_inventory_management":"shopify","properties":[],"product_exists":true,"fulfillable_quantity":1,"grams":4536,"price":"43.06","total_discount":"0.00","fulfillment_status":null,"price_set":{"shop_money":{"amount":"43.06","currency_code":"CAD"},"presentment_money":{"amount":"43.06","currency_code":"CAD"}},"total_discount_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"discount_allocations":[],"tax_lines":[{"price":"1.92","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.92","currency_code":"CAD"},"presentment_money":{"amount":"1.92","currency_code":"CAD"}}},{"price":"2.69","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.69","currency_code":"CAD"},"presentment_money":{"amount":"2.69","currency_code":"CAD"}}}]},{"id":5744092774488,"variant_id":33410355134552,"title":"1\" Signature Faux Wood Blinds","quantity":1,"sku":"300915","variant_title":null,"vendor":"Mariak","fulfillment_service":"manual","product_id":4781806059608,"requires_shipping":true,"taxable":true,"gift_card":false,"name":"1\" Signature Faux Wood Blinds","variant_inventory_management":"shopify","properties":[],"product_exists":true,"fulfillable_quantity":0,"grams":4536,"price":"38.11","total_discount":"0.00","fulfillment_status":null,"price_set":{"shop_money":{"amount":"38.11","currency_code":"CAD"},"presentment_money":{"amount":"38.11","currency_code":"CAD"}},"total_discount_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"discount_allocations":[],"tax_lines":[{"price":"1.70","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.70","currency_code":"CAD"},"presentment_money":{"amount":"1.70","currency_code":"CAD"}}},{"price":"2.38","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.38","currency_code":"CAD"},"presentment_money":{"amount":"2.38","currency_code":"CAD"}}}]}],"fulfillments":[],"refunds":[{"id":675014869080,"order_id":2706454642776,"created_at":"2020-10-11T20:23:17-07:00","note":null,"user_id":40722038872,"processed_at":"2020-10-11T20:23:17-07:00","restock":true,"refund_line_items":[{"id":184205639768,"line_item_id":5744092774488,"quantity":1,"restock_type":"cancel","location_id":4928765993,"subtotal":"38.11","total_tax":"4.08","line_item":{"id":5744092774488,"variant_id":33410355134552,"title":"1\" Signature Faux Wood Blinds","quantity":1,"sku":"300915","variant_title":null,"vendor":"Mariak","fulfillment_service":"manual","product_id":4781806059608,"requires_shipping":true,"taxable":true,"gift_card":false,"name":"1\" Signature Faux Wood Blinds","variant_inventory_management":"shopify","properties":[],"product_exists":true,"fulfillable_quantity":0,"grams":4536,"price":"38.11","total_discount":"0.00","fulfillment_status":null,"price_set":{"shop_money":{"amount":"38.11","currency_code":"CAD"},"presentment_money":{"amount":"38.11","currency_code":"CAD"}},"total_discount_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"discount_allocations":[],"tax_lines":[{"price":"1.70","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.70","currency_code":"CAD"},"presentment_money":{"amount":"1.70","currency_code":"CAD"}}},{"price":"2.38","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.38","currency_code":"CAD"},"presentment_money":{"amount":"2.38","currency_code":"CAD"}}}]},"subtotal_set":{"shop_money":{"amount":"38.11","currency_code":"CAD"},"presentment_money":{"amount":"38.11","currency_code":"CAD"}},"total_tax_set":{"shop_money":{"amount":"4.08","currency_code":"CAD"},"presentment_money":{"amount":"4.08","currency_code":"CAD"}}}],"transactions":[],"order_adjustments":[]}],"total_tip_received":"0.0","shipping_lines":[]}';
        $response = '{"id":2711697358936,"email":"","closed_at":null,"created_at":"2020-10-14T07:00:04-07:00","updated_at":"2020-10-14T07:00:32-07:00","number":2534,"note":"","token":"f1525e2b7df6253d2444f615a3f4531c","gateway":"manual","test":false,"total_price":"248.58","subtotal_price":"248.58","total_weight":27215,"total_tax":"26.64","taxes_included":true,"currency":"CAD","financial_status":"partially_paid","confirmed":true,"total_discounts":"0.00","total_line_items_price":"248.58","cart_token":null,"buyer_accepts_marketing":false,"name":"#3534","referring_site":null,"landing_site":null,"cancelled_at":null,"cancel_reason":null,"total_price_usd":"189.16","checkout_token":null,"reference":null,"user_id":40722038872,"location_id":4928765993,"source_identifier":null,"source_url":null,"processed_at":"2020-10-14T07:00:04-07:00","device_id":null,"phone":null,"customer_locale":null,"app_id":1354745,"browser_ip":null,"landing_site_ref":null,"order_number":3534,"discount_applications":[],"discount_codes":[],"note_attributes":[{"name":"Final : 1\" Mini Blind 8 Gauge","value":2},{"name":"Final : 1\" Premier Basswood Blinds","value":2}],"payment_gateway_names":["manual"],"processing_method":"manual","checkout_id":null,"source_name":"shopify_draft_order","fulfillment_status":null,"tax_lines":[{"price":"11.10","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"11.10","currency_code":"CAD"},"presentment_money":{"amount":"11.10","currency_code":"CAD"}}},{"price":"15.54","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"15.54","currency_code":"CAD"},"presentment_money":{"amount":"15.54","currency_code":"CAD"}}}],"tags":"lineitem updated","contact_email":null,"order_status_url":"https:\/\/p80w-devstore-8.myshopify.com\/31051616\/orders\/f1525e2b7df6253d2444f615a3f4531c\/authenticate?key=dea295b210b51b54ec165905cd743b03","presentment_currency":"CAD","total_line_items_price_set":{"shop_money":{"amount":"248.58","currency_code":"CAD"},"presentment_money":{"amount":"248.58","currency_code":"CAD"}},"total_discounts_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"total_shipping_price_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"subtotal_price_set":{"shop_money":{"amount":"248.58","currency_code":"CAD"},"presentment_money":{"amount":"248.58","currency_code":"CAD"}},"total_price_set":{"shop_money":{"amount":"248.58","currency_code":"CAD"},"presentment_money":{"amount":"248.58","currency_code":"CAD"}},"total_tax_set":{"shop_money":{"amount":"26.64","currency_code":"CAD"},"presentment_money":{"amount":"26.64","currency_code":"CAD"}},"line_items":[{"id":5754399948888,"variant_id":33369633259608,"title":"1\" Mini Blind 8 Gauge","quantity":3,"sku":"M-1AH-8G","variant_title":null,"vendor":"FDB","fulfillment_service":"manual","product_id":4764882403416,"requires_shipping":true,"taxable":true,"gift_card":false,"name":"1\" Mini Blind 8 Gauge","variant_inventory_management":"shopify","properties":[],"product_exists":true,"fulfillable_quantity":3,"grams":4536,"price":"39.80","total_discount":"0.00","fulfillment_status":null,"price_set":{"shop_money":{"amount":"39.80","currency_code":"CAD"},"presentment_money":{"amount":"39.80","currency_code":"CAD"}},"total_discount_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"discount_allocations":[],"tax_lines":[{"price":"3.56","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"3.56","currency_code":"CAD"},"presentment_money":{"amount":"3.56","currency_code":"CAD"}}},{"price":"1.78","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.78","currency_code":"CAD"},"presentment_money":{"amount":"1.78","currency_code":"CAD"}}},{"price":"2.49","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.49","currency_code":"CAD"},"presentment_money":{"amount":"2.49","currency_code":"CAD"}}},{"price":"4.98","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"4.98","currency_code":"CAD"},"presentment_money":{"amount":"4.98","currency_code":"CAD"}}}]},{"id":5754399981656,"variant_id":33369633423448,"title":"1\" Premier Basswood Blinds","quantity":3,"sku":"M-1BW","variant_title":null,"vendor":"p80w-devstore-8","fulfillment_service":"manual","product_id":4764882501720,"requires_shipping":true,"taxable":true,"gift_card":false,"name":"1\" Premier Basswood Blinds","variant_inventory_management":"shopify","properties":[],"product_exists":true,"fulfillable_quantity":3,"grams":4536,"price":"43.06","total_discount":"0.00","fulfillment_status":null,"price_set":{"shop_money":{"amount":"43.06","currency_code":"CAD"},"presentment_money":{"amount":"43.06","currency_code":"CAD"}},"total_discount_set":{"shop_money":{"amount":"0.00","currency_code":"CAD"},"presentment_money":{"amount":"0.00","currency_code":"CAD"}},"discount_allocations":[],"tax_lines":[{"price":"3.84","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"3.84","currency_code":"CAD"},"presentment_money":{"amount":"3.84","currency_code":"CAD"}}},{"price":"1.92","rate":0.05,"title":"GST","price_set":{"shop_money":{"amount":"1.92","currency_code":"CAD"},"presentment_money":{"amount":"1.92","currency_code":"CAD"}}},{"price":"2.69","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"2.69","currency_code":"CAD"},"presentment_money":{"amount":"2.69","currency_code":"CAD"}}},{"price":"5.38","rate":0.07,"title":"PST","price_set":{"shop_money":{"amount":"5.38","currency_code":"CAD"},"presentment_money":{"amount":"5.38","currency_code":"CAD"}}}]}],"fulfillments":[],"refunds":[],"total_tip_received":"0.0","shipping_lines":[]}';
        $orderData = json_decode($response);
// print_r($orderData);die;
        $orderId = $orderData->id;
        Log::info("Processing order - ".$orderId);
// die('test');
        $emailId = $orderData->email;
        $orderName = $orderData->name;

        $noteAttributes = $this->formatData($orderData->note_attributes);

        foreach($orderData->line_items as $orderLineItem) {

            if(!isset($webhook[$orderLineItem->variant_id])) {

                $webhook[$orderLineItem->variant_id]['title'] = $orderLineItem->title;
                $webhook[$orderLineItem->variant_id]['quantity'] = $orderLineItem->quantity;
                $webhook[$orderLineItem->variant_id]['variant_id'] = $orderLineItem->variant_id;
                $webhook[$orderLineItem->variant_id]['price'] = $orderLineItem->price;
                
            }
        }

        $res = $this->getOrderFulfillment($orderId);
        $count = count($res);
        $request = array();

        foreach($res[$count-1]['line_items'] as $lineItem) {
    
            if(!isset($currentOrder[$lineItem['variant_id']])) {

                $variantName = isset($webhook[$lineItem['variant_id']]) ? $webhook[$lineItem['variant_id']]['title']: '';
                
                $currentOrder[$lineItem['variant_id']]['variant_id'] = $lineItem['variant_id'];
                $currentOrder[$lineItem['variant_id']]['quantity'] = $lineItem['quantity'];
                $currentOrder[$lineItem['variant_id']]['title'] = $variantName;

                $temp = [];
                $temp['name'] = "Final : " . $variantName;
                $temp['value'] = $lineItem['quantity'];
                $request[] = $temp;
            }
        }
    
        foreach($res[0]['line_items'] as $Item) {

            if(!isset($initalOrder[$Item['variant_id']])) {

                $initalOrder[$Item['variant_id']]['variant_id'] = $Item['variant_id'];
                $initalOrder[$Item['variant_id']]['quantity'] = $Item['quantity'];
            }
        }

        $lastUpdate = $this->formatLastUpdate($currentOrder);

        if(empty($noteAttributes['noteAttributes'])){
            // no need to send mail
            echo "test";
            $this->updateNoteAttributes($orderData, $noteAttributes['fullNoteAttributes'], $lastUpdate);
            die;
        }

        if(count($noteAttributes['noteAttributes']) !== count($currentOrder)) {
            // need to send mail 

            $this->sendEditMail($webhook, $initalOrder, $currentOrder, $orderData);
            $this->updateNoteAttributes($orderData, $noteAttributes['fullNoteAttributes'], $lastUpdate);

            die;
        } else {
            // check codition  and send mail 
            $sendMail = false;
            foreach ($noteAttributes['noteAttributes'] as $name => $value) {
                if (isset($lastUpdate[$name]) && $value !==  $lastUpdate[$name]){
                    $sendMail = true;
                }
            }
        }

        if($sendMail) {
            // send mail
        
            $this->updateNoteAttributes($orderData, $noteAttributes['fullNoteAttributes'], $lastUpdate);
            $this->sendEditMail($webhook, $initalOrder, $currentOrder, $orderData);
            die('send mail => some value changes');

        } else {
            die('send mail => no need');
        }

        die;
    }

    function formatLastUpdate($currentOrder){

        $returnArray = array();
        if(!empty($currentOrder)){
            foreach($currentOrder as $orderID => $orderDetails) {
                $returnArray[$orderDetails['title']] = $orderDetails['quantity'];
            }
        }

        return $returnArray;
    }

    public function formatData($noteAttributes) {
        $returnArray = [];
        $fullNoteAttributes = [];
        if(!empty($noteAttributes)){
            foreach($noteAttributes as $attributes) {
                $name = $attributes->name;
                $value = $attributes->value;
                
                if(strpos($attributes->name, "Final : ") !== false){
                    $name = str_replace("Final : ", "", $attributes->name);
                    $returnArray[$name] = $value;
                }
                $fullNoteAttributes[$name] = $value;
            }
        }

        return [
            "noteAttributes" => $returnArray,
            "fullNoteAttributes" => $fullNoteAttributes
        ];
    }

    public function updateNoteAttributes($data, $noteAttributes, $updatedData) {

        $orderId = $data->id;
        $orderTag = $data->tags;
        $orderNoteAttributes = $data->note_attributes;
        $noteRequest = [];

        print_r($noteAttributes);
        print_r($orderNoteAttributes);
        print_r($updatedData);

        // update note attributes
        if(!empty($updatedData)) {
            foreach($updatedData as $name => $value) {

                if(!empty($orderNoteAttributes)) {
                    foreach($orderNoteAttributes as $key => $noteValues) {
                        
                        $noteName = $noteValues->name;
                        $noteQty  = $noteValues->value;
    
                        $checkName = str_replace("Final : ", "", $noteName);
    
                        if(strpos($noteName, $name) !== false) {
                            $noteQty = $value;
                            $orderNoteAttributes[$key]->value = $noteQty;
                        }
                        
                        // if(!array_key_exists($checkName, $updatedData)) {
                    
                        //     unset($orderNoteAttributes[$key]);
                        // }
                    }
                }

                if(!array_key_exists($name, $noteAttributes)){
                    $temp['name'] = "Final : ".$name;
                    $temp['value'] = $value;
                    $orderNoteAttributes[] = $temp;
                }  
            }
        }

        $newAttributes = (array)$orderNoteAttributes;

        $request['order']['id'] = $orderId;
        $request['order']['note_attributes'] = $newAttributes;
        $request['order']['tags'] = $orderTag.", lineitem updated";
        $result = $this->api->rest(
            'PUT',
            '/admin/api/'.env('SHOPIFY_API_VER_DEV').'/orders/'.$orderId.'.json',
            $request
        );
        
        if (isset($result->errors) && $result->errors == true) {

            echo "error";
            return null;
        } else {

            $updatedOrder = $result['body']->container['order'];
        }
    }

    public function getOrderFulfillment($orderId) {

        $result = $this->api->rest(
            'GET',
            '/admin/api/'.env('SHOPIFY_API_VER_DEV').'/orders/'.$orderId.'/fulfillment_orders.json',
            null
        );

        if (isset($result->errors) && $result->errors == true) {
            return null;
        } else {

            $fulfillmentDetails = $result['body']->container['fulfillment_orders'];
        }

        return $fulfillmentDetails;
    }

    public function setLineItemDetails($webhook, $initalOrder, $currentOrder, $orderData) {

        $lineItemContent = '';
        foreach($currentOrder as $variantId => $variantDetails){

            $productName = '';
            $oldQty = '';
            $newQty = '';

            if(isset($initalOrder[$variantId])) {
                $productName = $variantDetails['title'];
                $productQty = $variantDetails['quantity'];
                $oldQty = $initalOrder[$variantId]['quantity'];
                $newQty = $currentOrder[$variantId]['quantity'];
                $price = isset($webhook[$variantId]) ? $webhook[$variantId]['price'] : '0.00';
                $total = $price * $productQty;

                $lineItemContent .= '<tbody>
                <tr class="order-list__item" style="width: 100%;">
                <td class="order-list__item__cell"
                style="font-family: -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Roboto&quot;, &quot;Oxygen&quot;, &quot;Ubuntu&quot;, &quot;Cantarell&quot;, &quot;Fira Sans&quot;, &quot;Droid Sans&quot;, &quot;Helvetica Neue&quot;, sans-serif; padding-bottom: 15px;">
                <table style="border-spacing: 0; border-collapse: collapse;">
                <tbody>
                <tr>
                <td
                style="font-family: -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Roboto&quot;, &quot;Oxygen&quot;, &quot;Ubuntu&quot;, &quot;Cantarell&quot;, &quot;Fira Sans&quot;, &quot;Droid Sans&quot;, &quot;Helvetica Neue&quot;, sans-serif;">
                <img align="left" alt="" class="order-list__product-image" height="60"
                src="https://cdn.shopify.com/s/files/1/0066/7569/3639/products/NM2844L600VITD3GUMMIESfront_compact_cropped.jpg?v=1588875151"
                style="margin-right: 15px; border-radius: 8px; border: 1px solid #e5e5e5;" width="60" />
                </td>
                <td class="order-list__product-description-cell"
                style="font-family: -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Roboto&quot;, &quot;Oxygen&quot;, &quot;Ubuntu&quot;, &quot;Cantarell&quot;, &quot;Fira Sans&quot;, &quot;Droid Sans&quot;, &quot;Helvetica Neue&quot;, sans-serif; width: 100%;">
                <span class="order-list__item-title"
                style="font-size: 16px; font-weight: 600; line-height: 1.4; color: #555;">Nature Made®
                Vitamin D3 Gummies&nbsp;×&nbsp;1</span>
                <br />
                <span class="order-list__item-variant" style="font-size: 14px; color: #999;">90</span>
                </td>
                <td class="order-list__price-cell"
                style="font-family: -apple-system, BlinkMacSystemFont, &quot;Segoe UI&quot;, &quot;Roboto&quot;, &quot;Oxygen&quot;, &quot;Ubuntu&quot;, &quot;Cantarell&quot;, &quot;Fira Sans&quot;, &quot;Droid Sans&quot;, &quot;Helvetica Neue&quot;, sans-serif; white-space: nowrap;">
                <p align="right" class="order-list__item-price"
                style="color: #555; line-height: 150%; font-size: 16px; font-weight: 600; margin: 0 0 0 15px;">
                $10.29
                </p>
                </td>
                </tr>
                </tbody>
                </table>
                </td>
                </tr>
               </tbody>';

            } else {

                $productName = $variantDetails['title'];
                $productQty = $variantDetails['quantity'];
                $price = isset($webhook[$variantId]) ? $webhook[$variantId]['price'] : '0.00';
                $total = $price * $productQty;

                $lineItemContent .= '<table style="border-bottom:1px solid #E5E5E5;">
                <tbody>
                  <tr style="width:100%;">
                    <td style="width: auto; padding: 5px"><span style="color:#555555;font-size:16px;font-weight:600;line-height:1.4;">'.$productName.'&nbsp;×&nbsp; '.$productQty.' </span>
                    </td>
                    <td style="width: 10%">
                      <p align="right" style="color:#555555;font-size:16px;font-weight:600;margin:0 0 0 15px;line-height:150%;">'.$total.'
                      </p>
                    </td>
                  </tr>
                </tbody>
              </table>';
            }
        }

        return $lineItemContent;
    }

    public function sendEditMail($webhook, $initalOrder, $currentOrder, $orderData) {

        $orderName = $orderData->name;
        $orderTotal = '$'.$orderData->total_price;
        $subTotal = '$'.$orderData->subtotal_price;
        $address = $this->getAddressContent($orderData);
        $totalTax = '$'.$orderData->total_tax;
        $currency = $orderData->currency;
        $paymentName = isset($orderData->payment_gateway_names[0]) ? $orderData->payment_gateway_names[0] : '';
        $shippingName = isset($orderData->shipping_lines[0]->title) ? $orderData->shipping_lines[0]->title : '';
        $lineItemDetails = $this->setLineItemDetails($webhook, $initalOrder, $currentOrder, $orderData);

        $email = 'testing@p80w.com';
        $iterableMailRequest = array(

            "campaignId" => intval(env('ITERABLE_CAMPAIGN_ID',true)),
            "recipientEmail" => $email,
            "dataFields" => array(
                "orderName" => $orderName,
                "totalPrice" => $orderTotal,
                "shippingAddress" => $address['shippingAddress'],
                "billingAddress" => $address['billingAddress'],
                "subTotal" => $subTotal,
                "totalTax" => $totalTax,
                "currency" => $currency,
                "shippingName" => $shippingName,
                "paymentName" => $paymentName,
                "lineItemDetails" => $lineItemDetails
            )
        );

         print_r($iterableMailRequest);

        $mailTriggerResponse = $this->iterableObj->sendMailFromIterable(json_encode($iterableMailRequest));
 print_r($mailTriggerResponse);die("res");
        if (strtolower(trim($mailTriggerResponse->code)) == 'success') {
            echo "mail send....... ";
            Log::info('mail send.......');
            $returnData = [
                "mailStatus" => true,
                "message" => "mail triggered successfully (".$email.")"
            ];

            return 'suceess';

        } else {
            echo "mail not send....... ";
            Log::info('mail  not send.......');
            Log::info(json_encode($mailTriggerResponse));   
            $error = $mailTriggerResponse->code;

            if (empty($error)) {

                $returnData = [
                    'error' => 'failed to send mail('.$email.')'
                ];
            } else {

                $returnData = [
                    'error' => $error.' ('.$email.')'
                ];
            }
            return 'Error';
        }


    }
    
    public function getAddressContent($orderData) {

        $shippingAddress = isset($orderData->shipping_address) ? $orderData->shipping_address : '';
        $billingAddress = isset($orderData->billing_address) ? $orderData->billing_address : '';

        $shipingAddressContent = '';
        $billingAddressContent = '';

        if(!empty($shippingAddress)) {
            $shipingAddressContent .= '
            <p style="color:#777777;font-size:16px;margin:0;line-height:150%;">'.
            $shippingAddress->first_name. '  ' . $shippingAddress->last_name .
            '<br />'.$shippingAddress->company .'<br />'.
            $shippingAddress->address1. '<br />'.$shippingAddress->province.
            '<br />'.$shippingAddress->country. '<br />'.$shippingAddress->zip.'</p>';
        } else {
            $shipingAddressContent .= '
            <p style="color:#777777;font-size:16px;margin:0;line-height:150%;">'.
            '  <br />  <br /> <br /> <br /> <br /> </p>';
        }

        if(!empty($billingAddress)) {
            $billingAddressContent .= '
            <p style="color:#777777;font-size:16px;margin:0;line-height:150%;">'.
            $billingAddress->first_name. '  ' . $billingAddress->last_name .
            '<br />'.$billingAddress->company .'<br />'.
            $billingAddress->address1. '<br />'.$billingAddress->province.
            '<br />'.$billingAddress->country. '<br />'.$billingAddress->zip.'</p>';
        } else {
            $billingAddressContent .= '
            <p style="color:#777777;font-size:16px;margin:0;line-height:150%;">'.
            '  <br />  <br /> <br /> <br /> <br /> </p>';
        }

        return [
            "billingAddress" => $billingAddressContent,
            "shippingAddress" => $shipingAddressContent
        ];

    }
    
}
